/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2007 by GJ Business Division RICOH COMPANY,LTD. JAPAN  
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: dbgu_serial.c 1560 2009-05-18 13:03:14Z ertl-honda $
 */

/*
 *  ꥢI/OǥХSIO˥ɥ饤СAT91SAM7Sѡ
 */

#include <kernel.h>
#include <t_syslog.h>
#include "at91sam7s.h"
#include "target_serial.h"

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block 
{
    void* uart_base;
    void* linectrl_pdr;
    uint32_t pdr_bit;
}
SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block 
{
    const SIOPINIB  *p_siopinib;  /* ꥢI/OݡȽ֥å */
    intptr_t  exinf;              /* ĥ */
    bool_t    openflag;           /* ץѤߥե饰 */
    bool_t    sendflag;           /* ߥ֥͡ե饰 */
    bool_t    getready;           /* ʸ */
    bool_t    putready;           /* ʸǤ */
};

/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_SIOP] = {
    {(void*)(TADR_DBGU_BASE),
     (void*)(TADR_PIO_BASE+TOFF_PIO_PDR),
     (uint32_t)(TOFF_PIO_PDR_VAL)
    }
};

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB	siopcb_table[TNUM_SIOP];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)  ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)  (&(siopcb_table[INDEX_SIOP(siopid)]))

/*
 * ʸ?
 */ 
Inline bool_t
uart_getready(SIOPCB *p_siopcb)
{
    return(((sil_rew_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_US_CSR)) & US_RXRDY)!=0));
}

/*
 * ʸǤ뤫?
 */
Inline bool_t
uart_putready(SIOPCB *p_siopcb)
{
    return((sil_rew_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_US_CSR)) & US_TXEMPTY)!=0);
}

/*
 *  ʸμФ
 */
Inline uint8_t
uart_getchar(SIOPCB *p_siopcb)
{
    return(sil_rew_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_US_RHR)));
}

/*
 *  ʸν񤭹
 */
Inline void
uart_putchar(SIOPCB *p_siopcb, uint8_t c)
{
    sil_wrw_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_US_THR),c);
}

/*
 *  ߵ
 */
Inline void
uart_enable_send(SIOPCB *p_siopcb)
{
    sil_wrw_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_US_IER), US_TXEMPTY);
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_send(SIOPCB *p_siopcb)
{
    sil_wrw_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_US_IDR), US_TXEMPTY);
}


/*
 *  ߵ
 */
Inline void
uart_enable_rcv(SIOPCB *p_siopcb)
{
    sil_wrw_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_US_IER), US_RXRDY);
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_rcv(SIOPCB *p_siopcb)
{
    sil_wrw_mem((void*)(p_siopcb->p_siopinib->uart_base+TOFF_US_IDR), US_RXRDY);
}


/*
 *  SIOɥ饤Фν
 */
void
sio_initialize(intptr_t exinf)
{
    SIOPCB  *p_siopcb;
    uint_t  i;

    /*
     *  ꥢI/Oݡȴ֥åν
     */
    for (p_siopcb = siopcb_table, i = 0; i < TNUM_SIOP; p_siopcb++, i++) {
        p_siopcb->p_siopinib = &(siopinib_table[i]);
        p_siopcb->openflag = false;
        p_siopcb->sendflag = false;
    }
}

/*
 * ꥢI/OݡȤΥץ
 */
SIOPCB *
at91sam7s_uart_opn_por(SIOPCB *p_siopcb, intptr_t exinf)
{
    uint32_t baud = ((MCK * 10) / (BAUDRATE * 16));
    const SIOPINIB  *p_siopinib;
    p_siopinib = p_siopcb->p_siopinib;

    /* Disable Interrupt */
    sil_wrw_mem((void*)(p_siopinib->uart_base+TOFF_US_IDR), 0xFFFFFFFF);
           
    /* ػ */
    sil_wrw_mem((void*)(p_siopinib->uart_base+TOFF_US_CR), (US_RSTRX|US_RSTTX|US_RXDIS|US_TXDIS));

    sil_wrw_mem((void*)(p_siopinib->uart_base+TOFF_PDC_RCR), 0);
    sil_wrw_mem((void*)(p_siopinib->uart_base+TOFF_PDC_TCR), 0);
    
    /* PIOAPA9,PA10UARTǻ */
    sil_wrw_mem((void*)p_siopinib->linectrl_pdr, p_siopinib->pdr_bit);
    
    /* 8Data, 1Stop, No Parity */
    sil_wrw_mem((void*)(p_siopinib->uart_base+TOFF_US_MR), (US_CLKS_MCK|US_CHRL_8|US_PAR_NO|US_NBSTOP_1|US_CHMODE_NORMAL));
    
    /* 115200bps */
    if((baud % 10) >= 5){
        sil_wrw_mem((void*)(p_siopinib->uart_base+TOFF_US_BRGR), (baud/10)+1);
    } else {
        sil_wrw_mem((void*)(p_siopinib->uart_base+TOFF_US_BRGR), (baud/10));
    }
    
    sil_wrw_mem((void*)(p_siopinib->uart_base+TOFF_US_TTGR), 0);
    sil_wrw_mem((void*)(p_siopinib->uart_base+TOFF_US_CR), US_TXEN|US_RXEN);
    
    sil_rew_mem((void*)(p_siopinib->uart_base+TOFF_US_RHR));

    /*
     *  ܡ졼Ԥ
     */
    sil_dly_nse(200000);

    p_siopcb->exinf = exinf;
    p_siopcb->getready = p_siopcb->putready = false;
    p_siopcb->openflag = true;

    return(p_siopcb);
}


/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
    SIOPCB  *p_siopcb = get_siopcb(siopid);
    bool_t  opnflg;
    ER      ercd;

    /*
     *  ץ󤷤ݡȤ뤫opnflgɤǤ
     */
    opnflg = p_siopcb->openflag;

    /*
     *  ǥХ¸Υץ
     */
    at91sam7s_uart_opn_por(p_siopcb, exinf);

    /*
     *  ꥢI/OߤΥޥ롥
     */
    if (!opnflg) {
        ercd = ena_int(INTNO_SIO);
        assert(ercd == E_OK);
    }
    return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
    /*
     *  ǥХ¸Υ
     */
    const SIOPINIB  *p_siopinib;

    p_siopinib = p_siopcb->p_siopinib;
    sil_wrw_mem((void*)(p_siopinib->uart_base+TOFF_US_CR), US_RSTRX|US_RSTTX|US_RXDIS|US_TXDIS);
    p_siopcb->openflag = false;
    
    /*
     *  ꥢI/Oߤޥ롥
     */
    dis_int(INTNO_SIO);    
}

/*
 *  SIOγߥϥɥ
 */
void
sio_isr(intptr_t exinf)
{
    SIOPCB *p_siopcb = &(siopcb_table[0]);

    if (uart_getready(p_siopcb)) {
        /*
         *  ΥХå롼ƤӽФ
         */
        sio_irdy_rcv(p_siopcb->exinf);
    }
    if (uart_putready(p_siopcb)) {
        /*
         *  ǽХå롼ƤӽФ
         */
        sio_irdy_snd(p_siopcb->exinf);
    }    
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char_t c)
{
    if (uart_putready(siopcb)) {
        uart_putchar(siopcb, c);
        return(true);
    }
    return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
sio_rcv_chr(SIOPCB *siopcb)
{
    if (uart_getready(siopcb)) {
        return((int_t)(uint8_t) uart_getchar(siopcb));
    }
    return(false);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
        case SIO_RDY_SND:
            uart_enable_send(siopcb);
            break;
        case SIO_RDY_RCV:
            uart_enable_rcv(siopcb);
            break;
    }
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
    switch (cbrtn) {
        case SIO_RDY_SND:
            uart_disable_send(siopcb);
            break;
        case SIO_RDY_RCV:
            uart_disable_rcv(siopcb);
            break;
    }
}
