/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _TINET_TARGET_CONFIG_H_
#define _TINET_TARGET_CONFIG_H_

/*
 *  TCP/IP ˴ؤ
 */

/* TCP ˴ؤ */

/*
 *  MAX_TCP_SND_SEG: ȥκ
 *
 *    ꤫ MSS ץǥȥꤵƤ⡢
 *    ͤǡȥ¤Ǥ롣
 */

#ifndef MAX_TCP_SND_SEG
#define MAX_TCP_SND_SEG		(IF_MTU - (IP_HDR_SIZE + TCP_HDR_SIZE))
#endif	/* of #ifndef MAX_TCP_SND_SEG */

/*
 *  DEF_TCP_RCV_SEG: ȥε
 */

#ifndef DEF_TCP_RCV_SEG
#define DEF_TCP_RCV_SEG		(IF_MTU - (IP_HDR_SIZE + TCP_HDR_SIZE))
#endif	/* of #ifndef DEF_TCP_RCV_SEG */

/* 
 *  Ȥν֤ؤȤ˿˥ͥåȥХåեƤơ
 *  ǡ򥳥ԡ륵Τ
 */
#define MAX_TCP_REALLOC_SIZE	1024	

#define TCP_CFG_OPT_MSS		/* ͥ߻ˡȥץĤ롣*/
#define TCP_CFG_DELAY_ACK	/* ACK ٤餻ȤϥȤ򳰤			*/
#define TCP_CFG_ALWAYS_KEEP	/* ˥ץ饤֤ϥȤ򳰤		*/

/* UDP ˴ؤ */

#define UDP_CFG_IN_CHECKSUM	/* UDP ϥåԤϥȤ򳰤	*/
#define UDP_CFG_OUT_CHECKSUM	/* UDP νϥåԤϥȤ򳰤	*/

/* ICMPv4/v6 ˴ؤ */

#define ICMP_REPLY_ERROR		/* ICMP 顼åϥȤ򳰤*/

/* IPv4 ˴ؤ */

//#define IP4_CFG_FRAGMENT		/* ǡʬ䡦ƹԤϥȤ򳰤	*/
#define NUM_IP4_FRAG_QUEUE	2	/* ǡƹ塼			*/
#define IP4_CFG_FRAG_REASSM_SIZE	4096	/* IPv4 ƹХåե			*/

/* IPv6 ˴ؤ */

#define NUM_IP6_DAD_COUNT	1	/* ʣɥ쥹Фβ		*/
					/*  0 ꤹȡʣɥ쥹ФԤʤ	*/
#define NUM_ND6_CACHE_ENTRY	10	/* ٥åΥȥ			*/

/*
 *  IPv6 ѥۥȥåΥȥ
 *  0 ꤹIPv6 ѥۥȥåȹޤʤ
 */
#define NUM_IN6_HOSTCACHE_ENTRY	4

#ifdef SUPPORT_ETHER

#define IP6_CFG_AUTO_LINKLOCAL		/* 󥯥륢ɥ쥹μưԤϥȤ򳰤*/

/*
 *  ǥեȥ롼ꥹȤ˴ؤ
 */

/*
 *  ǥեȥ롼ꥹȤΥȥ
 *  ͤ 160 ꤹȥ롼Τʤ
 */
#define NUM_ND6_DEF_RTR_ENTRY		4

/*
 *  ץեåꥹȤ˴ؤ
 *  ͤ 16
 */
#define NUM_ND6_PREFIX_ENTRY		4	/*  ץեåꥹȤΥȥ			*/

/*
 *  ưΥ롼ϲ
 *  0 ꤹȥ롼Ϥʤ
 */
#define NUM_ND6_RTR_SOL_RETRY	3	

#define IP6_CFG_FRAGMENT		/* ǡʬ䡦ƹԤϥȤ򳰤	*/
#define NUM_IP6_FRAG_QUEUE	2	/* ǡƹ塼			*/
#define IP6_CFG_FRAG_REASSM_SIZE	4096	/* IPv6 ƹХåե			*/

#endif	/* of #ifdef SUPPORT_ETHER */

/*
 *  ǡ (ͥåȥ󥿥ե) ˴ؤ
 */

/*
 *  PPPǥ˴ؤ
 */

#define MODEM_CFG_DIAL		"ATD"	/* 륳ޥʸ			*/
#define MODEM_CFG_RETRY_CNT	3	/* ȥ饤			*/
#define MODEM_CFG_RETRY_WAIT	10000	/* ȥ饤ޤǤԤ [ms]	*/

/*
 *  PPPHDLC ˴ؤ
 */

#define DEF_LOCAL_ACCM		ULONG_C(0x000a0000)	/* ʬ ACCMXON  XOFF ΤѴ	*/
#define DEF_REMOTE_ACCM		ULONG_C(0xffffffff)	/*  ACCMͤѴ		*/

/*
 *  PPPLCP ˴ؤ
 */

#define LCP_CFG_MRU		UINT_C(0x0001)	/* MRU					*/
#define LCP_CFG_ACCM		UINT_C(0x0002)	/* ACCM					*/
#define LCP_CFG_MAGIC		UINT_C(0x0004)	/* ޥåֹ				*/
#define LCP_CFG_PCOMP		UINT_C(0x0008)	/* ץȥ̵ǽ			*/
#define LCP_CFG_ACCOMP		UINT_C(0x0010)	/* ɥ쥹			*/
#define LCP_CFG_PAP		UINT_C(0x0020)	/* PAP					*/
/*#define LCP_CFG_CHAP		UINT_C(0x0040)	   CHAP ϼͽ			*/

#ifdef LCP_CFG_MAGIC

#define LCP_ECHO_INTERVAL	(20*NET_TIMER_HZ)	/* 󥿡Х		*/
#define LCP_ECHO_FAILS		9			/* 			*/

#endif	/* of #ifdef LCP_CFG_MAGIC */

/*
 *  PPPPAP ˴ؤ
 */

#define DEF_PAP_TIMEOUT		(3*NET_TIMER_HZ)
#define DEF_PAP_REQTIME		(30*NET_TIMER_HZ)	/* ॢȽԤȤϥȤ򳰤*/
#define MAX_PAP_REXMT		10			/* ǧ׵κ	*/

/*
 *  NIC (NE2000 ߴ) ˴ؤ
 */

/* : 16 ӥåȥ⡼ɤ̤ */
#ifdef IF_ED_CFG_16BIT

#define NUM_IF_ED_TXBUF		2	/* Хåե			*/

#else	/* of #ifdef IF_ED_CFG_16BIT */

#define NUM_IF_ED_TXBUF		1	/* Хåե			*/

#endif	/* of #ifdef IF_ED_CFG_16BIT */

#define TMO_IF_ED_GET_NET_BUF	1	/* [ms] net_buf ॢ	*/
					/* [s] ॢ			*/
#define TMO_IF_ED_XMIT		(2*IF_TIMER_HZ)

/*#define IF_ED_CFG_ACCEPT_ALL		 ޥ㥹ȡ顼ե졼ȤϥȤ򳰤*/

/*
 *  ͥåȽϻˡNIC  net_buf ˻ꤹ롣
 *
 *  : ʲλϡǤꡢif_ed Ǥϡ
 *        ʤΤǡʲΥȤ򳰤ƤϤʤʤ
 */

/*#define ETHER_NIC_CFG_RELEASE_NET_BUF*/

/*
 *  NIC (RTL8019AS) ˴ؤ
 */

//#define ED_BASE_ADDRESS		ULONG_C(0x00200000)	/* NIC Υ쥸١ɥ쥹 */
#define ED_BASE_ADDRESS		ULONG_C(0xfffa0000)	/* NIC Υ쥸١ɥ쥹 */

#define TINTNO_IRQ5 16
#define INHNO_IF_ED		TINTNO_IRQ5		/* IRQ5 */
#define INTNO_IF_ED		TINTNO_IRQ5		/* IRQ5 */
// #define INTATR_IF_ED		(TA_NEGEDGE)		/* °	*/
#define INTATR_IF_ED		(TA_POSEDGE)		/* °	*/
#define INTPRI_IF_ED		(-1)						/* ͥ	*/

/*
 *  ARP ˴ؤ
 */

#define NUM_ARP_ENTRY		10			/* ARP å奨ȥ	*/

/*
 *  DHCP ˴ؤ
 *
 *    : TINET ϡDHCP Ƥʤѥץǡ
 *            DHCP å뤿Ǥ롣
 *            ޤߤ IPv4 ΤͭǤ롣
 */

/*#define DHCP_CFG					 DHCP ϥȤ򳰤*/

/*
 *  Ethernet ˴ؤ
 */

/*#define ETHER_CFG_ACCEPT_ALL		 ޥ㥹ȡ顼ե졼ȤϥȤ򳰤	*/
/*#define ETHER_CFG_UNEXP_WARNING	 󥵥ݡȥե졼ηٹɽȤϥȤ򳰤		*/
/*#define ETHER_CFG_802_WARNING		 IEEE 802.3 ե졼ηٹɽȤϥȤ򳰤		*/
/*#define ETHER_CFG_MCAST_WARNING	 ޥ㥹ȤηٹɽȤϥȤ򳰤		*/

/*
 *  ɥ쥹ꥹȤ˴ؤ
 */
#define NUM_IN6_IFADDR_ENTRY		5	/*  󥿥եΥɥ쥹ꥹȤΥȥ		*/

/*
 *  ѥͥåȥ˴ؤ
 */

/*
 *  ͥåȥХåե˴ؤ
 */

/* ͥåȥХåե */

#ifdef SUPPORT_PPP

/*
 *  PPP ǤϡѤ ͥåȥХåե PDU (1502) 
 *  ƤʤФʤʤΤ PDU ¿˳ݤ롣
 */

#ifndef NUM_MPF_NET_BUF_CSEG
#define NUM_MPF_NET_BUF_CSEG	2	/* IF + IP + TCP2 ʾ*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_CSEG */

#ifndef NUM_MPF_NET_BUF_64
#define NUM_MPF_NET_BUF_64	0	/* 64 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_64 */

#ifndef NUM_MPF_NET_BUF_128
#define NUM_MPF_NET_BUF_128	0	/* 128 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_128 */

#ifndef NUM_MPF_NET_BUF_256
#define NUM_MPF_NET_BUF_256	0	/* 256 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_256 */

#ifndef NUM_MPF_NET_BUF_512
#define NUM_MPF_NET_BUF_512	0	/* 512 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_512 */

#ifndef NUM_MPF_NET_BUF_1024
#define NUM_MPF_NET_BUF_1024	0	/* 1024 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_1024 */

#ifndef NUM_MPF_NET_BUF_IF_PDU
#define NUM_MPF_NET_BUF_IF_PDU	2	/* IF  PDU 	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_IF_PDU */

#ifndef NUM_MPF_NET_BUF4_REASSM

#if defined(SUPPORT_INET4) && defined(IP4_CFG_FRAGMENT)
#define NUM_MPF_NET_BUF4_REASSM	2	/* IPv4 ƹХåե	*/
#else
#define NUM_MPF_NET_BUF4_REASSM	0	/* IPv4 ƹХåե	*/
#endif

#endif	/* of #ifndef NUM_MPF_NET_BUF4_REASSM */

#ifndef NUM_MPF_NET_BUF6_REASSM

#if defined(SUPPORT_INET6) && defined(IP6_CFG_FRAGMENT)
#define NUM_MPF_NET_BUF6_REASSM	2	/* IPv6 ƹХåե	*/
#else
#define NUM_MPF_NET_BUF6_REASSM	0	/* IPv6 ƹХåե	*/
#endif

#endif	/* of #ifndef NUM_MPF_NET_BUF6_REASSM */

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

/*
 *  ͥåȤξΥͥåȥХåեγ
 */

/*
 *  !!
 *
 *  NE2000 ߴ NIC ΥǥХɥ饤Сif_edˤκĹ
 *  60ʥ饤󤷤 62˥ƥåȤΤ IF + IP +TCP 
 *  64 ƥåȤΥͥåȥХåեŬǤ롣
 */

#ifndef NUM_MPF_NET_BUF_CSEG
#define NUM_MPF_NET_BUF_CSEG	0	/* IF + IP + TCP	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_CSEG */

#ifndef NUM_MPF_NET_BUF_64
#define NUM_MPF_NET_BUF_64	2	/* 64 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_64 */

#ifndef NUM_MPF_NET_BUF_128
#define NUM_MPF_NET_BUF_128	0	/* 128 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_128 */

#ifndef NUM_MPF_NET_BUF_256
#define NUM_MPF_NET_BUF_256	0	/* 256 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_256 */

#ifndef NUM_MPF_NET_BUF_512
#define NUM_MPF_NET_BUF_512	0	/* 512 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_512 */

#if defined(SUPPORT_INET4)

#ifndef NUM_MPF_NET_BUF_IP_MSS
#define NUM_MPF_NET_BUF_IP_MSS	0	/* IF + 576 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_IP_MSS */

#endif	/* of #if defined(SUPPORT_INET4) */

#ifndef NUM_MPF_NET_BUF_1024
#define NUM_MPF_NET_BUF_1024	0	/* 1024 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_1024 */

#if defined(SUPPORT_INET6)

#ifndef NUM_MPF_NET_BUF_IPV6_MMTU
#define NUM_MPF_NET_BUF_IPV6_MMTU	0	/* IF + 1280	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_IPV6_MMTU */

#endif	/* of #if defined(SUPPORT_INET6) */

#ifndef NUM_MPF_NET_BUF_IF_PDU
#define NUM_MPF_NET_BUF_IF_PDU	4	/* IF  PDU 	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_IF_PDU */

#ifndef NUM_MPF_NET_BUF4_REASSM

#if defined(SUPPORT_INET4) && defined(IP4_CFG_FRAGMENT)
#define NUM_MPF_NET_BUF4_REASSM	2	/* IPv4 ƹХåե	*/
#else
#define NUM_MPF_NET_BUF4_REASSM	0	/* IPv4 ƹХåե	*/
#endif

#endif	/* of #ifndef NUM_MPF_NET_BUF4_REASSM */

#ifndef NUM_MPF_NET_BUF6_REASSM

#if defined(SUPPORT_INET6) && defined(IP6_CFG_FRAGMENT)
#define NUM_MPF_NET_BUF6_REASSM	2	/* IPv6 ƹХåե	*/
#else
#define NUM_MPF_NET_BUF6_REASSM	0	/* IPv6 ƹХåե	*/
#endif

#endif	/* of #ifndef NUM_MPF_NET_BUF6_REASSM */

#endif	/* of #ifdef SUPPORT_ETHER */

#ifdef SUPPORT_LOOP

#ifndef NUM_MPF_NET_BUF_CSEG
#define NUM_MPF_NET_BUF_CSEG	2	/* IF + IP + TCP	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_CSEG */

#ifndef NUM_MPF_NET_BUF_64
#define NUM_MPF_NET_BUF_64	0	/* 64 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_64 */

#ifndef NUM_MPF_NET_BUF_128
#define NUM_MPF_NET_BUF_128	0	/* 128 ƥåȡ2 ʾ	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_128 */

#ifndef NUM_MPF_NET_BUF_256
#define NUM_MPF_NET_BUF_256	0	/* 256 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_256 */

#ifndef NUM_MPF_NET_BUF_512
#define NUM_MPF_NET_BUF_512	0	/* 512 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_512 */

#ifndef NUM_MPF_NET_BUF_1024
#define NUM_MPF_NET_BUF_1024	0	/* 1024 ƥå	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_1024 */

#ifndef NUM_MPF_NET_BUF_IF_PDU
#define NUM_MPF_NET_BUF_IF_PDU	4	/* IF  PDU 	*/
#endif	/* of #ifndef NUM_MPF_NET_BUF_IF_PDU */

#endif	/* of #ifdef SUPPORT_PPP */

/*
 *  ͥåȥ׾η¬
 *
 *  ͥåȥ׾η¬Ԥϡtinet/include/net/net.h
 *  Ƥץȥ뼱̥ե饰ꤹ롣
 */

#if 1

#ifdef SUPPORT_INET4

#define NET_COUNT_ENABLE	(0			\
				| PROTO_FLG_PPP_HDLC	\
				| PROTO_FLG_PPP_PAP	\
				| PROTO_FLG_PPP_LCP	\
				| PROTO_FLG_PPP_IPCP	\
				| PROTO_FLG_PPP		\
				| PROTO_FLG_LOOP	\
				| PROTO_FLG_ETHER_NIC	\
				| PROTO_FLG_ETHER	\
				| PROTO_FLG_ARP		\
				| PROTO_FLG_IP4		\
				| PROTO_FLG_ICMP4	\
				| PROTO_FLG_UDP		\
				| PROTO_FLG_TCP		\
				| PROTO_FLG_NET_BUF	\
				)

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

#define NET_COUNT_ENABLE	(0			\
				| PROTO_FLG_PPP_HDLC	\
				| PROTO_FLG_PPP_PAP	\
				| PROTO_FLG_PPP_LCP	\
				| PROTO_FLG_PPP_IPCP	\
				| PROTO_FLG_PPP		\
				| PROTO_FLG_LOOP	\
				| PROTO_FLG_ETHER_NIC	\
				| PROTO_FLG_ETHER	\
				| PROTO_FLG_IP6		\
				| PROTO_FLG_ICMP6	\
				| PROTO_FLG_ND6		\
				| PROTO_FLG_UDP		\
				| PROTO_FLG_TCP		\
				| PROTO_FLG_NET_BUF	\
				)

#endif	/* of #ifdef SUPPORT_INET6 */

#else	/* of #if 0 */

#define NET_COUNT_ENABLE	(0			\
				)

#endif	/* of #if 0 */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ؿ
 */

extern void ed_bus_init (void);
extern void ed_inter_init (void);

#endif	/* of #ifndef TOPPERS_MACRO_ONLY */

#endif /* _TINET_TARGET_CONFIG_H_ */
