#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2012 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: gen_xml.rb 1725 2012-05-03 05:29:24Z okuma-top $
#++

#= TECS-GATE Ѥ XML 뤿 supplement 

INDENT = "    "

#== XML ݤˡregion, cell, call, entry դֹ
module NumberForXML
  def set_NumberForXML num
    @NumberForXML = num
  end
  def get_NumberForXML
    @NumberForXML
  end
end

#== Region
class Region
  include NumberForXML
  def self.gen_xml( root_region )
    begin
      file_name = $gen_base + "/" + $target + ".xml"
      dbgPrint "generating XML file:#{file_name}\n"
      file = AppFile.open( file_name )

      file.print <<EOT
<?xml version="1.0" encoding="UTF-8"?>
<TECS:GUI_Tool xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:TECS="http://www.toppers.jp/tecs.html">
EOT
      root_region.gen_xml( file, 0 )

      root_region.gen_xml_join( file, 1 )

      file.print <<EOT
</TECS:GUI_Tool>
EOT

      file.close
    rescue => evar
      Generator.error( "T9999 fail to create XML file #{file_name}")
      print_exception( evar )
    end
  end

  #=== Region# XML 
  # region Ȥ cell  XML 
  def gen_xml( file, indent )
    if @name != "::" then
      file.print <<EOT

#{INDENT*indent}<-- #{get_XML_path_str} -->
#{INDENT*indent}<region Name="#{@name}" RegionType="#{@region_type}">
EOT
    end

    cell_num = 0
    @cell_list.each{ |c|
      next if c.is_cloned?
      c.set_NumberForXML cell_num
      c.gen_xml( file, indent + 1 )
      cell_num += 1
    }

    reg_num = 0
    @namespace_list.each{ |ns|
      if ns.instance_of? Region then
        ns.set_NumberForXML reg_num
        ns.gen_xml( file, indent + 1 )
        reg_num += 1
      end
    }

    if @name != "::" then
      file.print <<EOT
#{INDENT*indent}</region>
EOT
    end
  end

  #=== Region# XML  join ʬ
  def gen_xml_join( file, indent )
    @cell_list.each{ |c|
      next if c.is_cloned?
      c.gen_xml_join( file, indent )
    }
    @namespace_list.each{ |ns|
      if ns.instance_of? Region then
        ns.gen_xml_join( file, indent )
      end
    }
  end

  #=== Region# XML Υѥ
  # //@region.1/@region2
  def get_XML_path_str
    if @name == "::" then
      return "/"
    else
      return @owner.get_XML_path_str + "/@region.#{@NumberForXML}"
    end
  end
end

class Cell
  include NumberForXML

  #=== Cell# 
  # entry, call ˤĤƤϡष celltype Ǥ
  # attr  cell ǽƤʤСcelltype Ǥνͤ VALUE ˽Ϥ
  def gen_xml(file, indent)
    # mikan celltype namespace path?
    file.print <<EOT

#{INDENT*indent}<-- #{@region.get_XML_path_str}/@cell.#{@NumberForXML} -->
#{INDENT*indent}<cell Name="#{@name}" CellType="#{@celltype.get_name}" isActive="#{@celltype.is_active?}" isSingletone="#{@celltype.is_singleton?}">
EOT

    @celltype.gen_xml_port( file, indent + 1 )
    @celltype.gen_xml_attr( file, indent + 1, self )

    file.print <<EOT
#{INDENT*indent}</cell>
EOT

    return true
  end

  #=== Cell# join(ؤη)  XML 
  def gen_xml_join(file, indent)

    @join_list.get_items.each{ |j|
      if j.get_definition.instance_of? Port then
        j.gen_xml( file, indent )
      end
    }
    return true
  end

end

#== CelltypeGenXML:: XML 뤿 celltype  composite ζ̥᥽å
module CelltypeGenXML
  include NumberForXML

  #=== CelltypeGenXML# Port(call ޤ entry)  XML 
  def gen_xml_port(file, indent)
    entry_num = 0
    call_num = 0
    @name_list.get_items.each{ |item|
      if item.instance_of?( Port ) then
        item.gen_xml( file, indent )
        case item.get_port_type
        when :ENTRY
          item.set_NumberForXML entry_num
          entry_num += 1
        when :CALL
          item.set_NumberForXML call_num
          call_num += 1
        end
      end
    }
  end

  #=== CelltypeGenXML# attr  XML 
  #cell:: Cell : VALUE  Cell  join ΤΤͥ褵
  def gen_xml_attr(file, indent, cell)
    @name_list.get_items.each{ |item|
      if item.instance_of?( Decl ) then
        if item.get_kind != :ATTRIBUTE then
          next
        end
        j = cell.get_join_list.get_item( item.get_name )
        if j then
          init = j.get_rhs   # Cell  Join α
        else
          init = item.get_initializer  # Celltype, CompositeCelltype  Decl ν
        end

        if init.instance_of? Array then
          init_str = "{"
          init.each{ |i|
            if i.instance_of? Array then
              # mikan Array  Array (ƵŪʽи)
              init_str += "{Array}, "
            elsif i.instance_of? C_EXP then
              init_str += "C_EXP( \\\"" + i.to_s + "\\\"), "
            else
              init_str += i.to_s + ", "
            end
          }
          init_str += "}"
        elsif init.instance_of? C_EXP then
          init_str = "C_EXP( \\\"" + init.to_s + "\\\")"
        else
          init_str = init.to_s
        end

        file.print <<EOT
#{INDENT*indent}<attribute Name="#{item.get_name}" Type="#{item.get_type.get_type_str}#{item.get_type.get_type_str_post}" Value="#{init_str}"/>
EOT
      end
    }
  end
end

class Celltype
  include CelltypeGenXML
end

class CompositeCelltype
  include CelltypeGenXML
end

class Port
  include NumberForXML
  def gen_xml(file, indent)
    case @array_size
    when nil
      isArray = false
      arraySize = 0
    when "[]"
      isArray = true
      arraySize = 0
    else
      isArray = true
      arraySize = @array_size
    end

    case @port_type
    when :ENTRY
      # mikan signature namespace path?
      file.print <<EOT
#{INDENT*indent}<entry Signature="#{@signature.get_name}" Name="#{@name}" isArray="#{isArray}" ArraySize="#{arraySize}"/>
EOT
    when :CALL
      file.print <<EOT
#{INDENT*indent}<call Signature="#{@signature.get_name}" Name="#{@name}" isArray="#{isArray}" ArraySize="#{arraySize}" isOptional="#{@b_optional}" isRequire="#{@b_require}"/>
EOT
    else
      raise "unknown port type"
    end
  end
end

class Join

  #=== Join# ؤη XML 
  # 쥷ФϥؤηǤ뤳
  def gen_xml( file, indent )
    src_str = get_owner.get_region.get_XML_path_str
    src_str += "/@cell.#{get_owner.get_NumberForXML}/@call.#{@definition.get_NumberForXML}"
    src_path = get_owner.get_namespace_path.get_path_str.to_s + "." + @definition.get_name.to_s

    dst_str = @cell.get_region.get_XML_path_str
    dst_str += "/@cell.#{@cell.get_NumberForXML}/@entry.#{@port.get_NumberForXML}"
    dst_path = @cell.get_namespace_path.get_path_str.to_s + "." + @port.get_name.to_s

    file.print <<EOT

#{INDENT*indent}<--  SrcPath=#{src_path} DstPath=#{dst_path} -->
#{INDENT*indent}<join target="#{dst_str}" source="#{src_str}"/>
EOT
  end
end
